version 6.0
#delimit ;
clear;

set seed 3634;

set obs 1000;			/* 1000 observations */


ge x1=uniform();			/* explanatory variables */
ge x2=uniform()-.5;			

ge e1=invnorm(uniform());	/* e1 = normally distributed disturbance */


/* next generate non-normal disturbance */

ge u1= (invnorm(uniform())-1.6);
ge u2= (invnorm(uniform())+1.6);	
ge ww=uniform();
ge w=ww>.8;

ge e2=w*u1+(1-w)*u2;		/* e2 = non-normal (see by graph e2!) */
qui sum e2;
replace e2=(e2-r(mean))/sqrt(r(Var));

drop u1 u2 ww w;


/* true model - select either e1 or e2 as disturbance */

ge y=-.3 + x1 + x2 + e2;			

ge ytob=y if y>0;				/* dependent variable in tobit */
replace ytob=0 if y<=0;

cmt ytob x1 x2, model(1);		/* CM test, tobit */

ge ydum=ytob>0;				/* dependent variable in probit */

cmt ydum x1 x2, model(2);		/* CM test, probit */

qui sum y, det;

ge ycat=1 if y<=r(p25);			/* dependent variable in ordered probit */
replace ycat=2 if y>r(p25) & y<=r(p75);
replace ycat=3 if y>r(p75);

cmt ycat x1 x2, model(3);		/* CM test, ordered probit */



